package es.upm.dit.adsw.tema3.balls.c_readers_writers;

public class RW_Monitor {
    private int nReaders;
    private int nWriters;

    public synchronized int getNReaders() {
        return nReaders;
    }

    public synchronized int getNWriters() {
        return nWriters;
    }

    public synchronized void openReading() {
        nReaders++;
        invariant();
    }

    public synchronized void closeReading() {
        nReaders--;
        invariant();
    }

    public synchronized void openWriting() {
        nWriters++;
        invariant();
    }

    public synchronized void closeWriting() {
        nWriters--;
        invariant();
    }

    void invariant() {
        if (getNReaders() > 0 && getNWriters() > 0)
            System.err.println("ERROR");
        if (getNWriters() > 1)
            System.err.println("ERROR");
    }

    void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
